--*******************************************************
-- Demo: XML values
-- Author: Dr. Can Trker
--*******************************************************-

SELECT XMLTYPE('<?xml version="1.0"?><book><title>Manual</title><chapter>...</chapter></book>') FROM dual;

SELECT XMLPARSE(DOCUMENT '<?xml version="1.0"?><book><title>Manual</title><chapter>...</chapter></book>') FROM dual;
SELECT XMLPARSE(DOCUMENT '<book><title>Manual</title><chapter>...</chapter></book>') FROM dual;
SELECT XMLPARSE(DOCUMENT '<book><title>Manual</title></book><chapter>...</chapter>') FROM dual;
SELECT XMLPARSE(CONTENT '<book><title>Manual</title></book><chapter>...</chapter>') FROM dual;
SELECT XMLPARSE(CONTENT 'abc<foo>bar</foo><bar>foo</bar>') FROM dual;

SELECT XMLSERIALIZE(DOCUMENT XMLTYPE('<?xml version="1.0"?><book><title>Manual</title><chapter>...</chapter></book>') AS CLOB) FROM dual;
SELECT XMLSERIALIZE(CONTENT XMLPARSE(CONTENT 'abc<foo>bar</foo><bar>foo</bar>') AS CLOB VERSION '1.0') FROM dual;

SELECT XMLCOMMENT('hello') FROM dual;
SELECT XMLPI(name php, 'echo "hello world"') FROM dual;

SELECT XMLELEMENT(name foo) FROM dual;
SELECT XMLELEMENT(name foo, xmlattributes('xyz' as bar)) FROM dual;
SELECT XMLELEMENT(name foo, xmlattributes(current_date as bar), 'cont', 'ent') FROM dual;
SELECT XMLFOREST('abc' AS foo, 123 AS bar) FROM dual;
SELECT XMLCONCAT(XMLTYPE('<abc/>'), XMLTYPE('<bar>foo</bar>')) FROM dual;

SELECT XMLCDATA('hello') FROM dual;
SELECT XMLROOT(XMLPARSE(DOCUMENT '<content>abc</content>'), VERSION '1.0', STANDALONE YES) FROM dual;
SELECT XMLROOT(XMLPARSE(DOCUMENT '<?xml version="2.0"?><content>abc</content>'), VERSION '1.0', STANDALONE YES) FROM dual;
SELECT XMLCOLATTVAL('elementcontent' as "attvalue") FROM dual;
