--*******************************************************
-- Demo: Oracle-XML 
-- Author: Dr. Can Trker
--*******************************************************

SET FEEDBACK 1;
SET ECHO ON;
SET LONG 8000;

--*******************************************************
-- Genarate XML schemata from object types
--*******************************************************

CREATE TYPE authorstype AS TABLE OF VARCHAR(30);
/

CREATE TYPE booktype AS OBJECT
(
  isbn      VARCHAR(15),
  title     VARCHAR(30),
  subtitle  VARCHAR(50),
  publisher VARCHAR(45),
  authors   authorstype,
  year      INTEGER
);
/

COLUMN XMLSchema FORMAT a78;

SELECT DBMS_XMLSchema.generateSchema('C##XMLDB', 'BOOKTYPE') AS XMLSchema 
FROM DUAL;

CREATE TABLE bookentity OF booktype NESTED TABLE authors STORE AS authors;

INSERT INTO bookentity VALUES('3-89864-148-1', 'XML und Datenbanken', 
'XML-Dokumente effizient speichern und verarbeiten',
'dpunkt', authorstype('Meike Klettke', 'Holger Meyer'), 2003);

INSERT INTO bookentity VALUES('3-8266-0258-7', 'entitydatenbanken', 
'Konzepte, Sprachen, Architekturen', 'International Thomson Publishing', 
authorstype('Gunter Saake', 'Ingo Schmitt', 'Can Trker'), 1997);

SELECT DBMS_XMLGEN.getXML('SELECT * FROM bookentity')
FROM DUAL;

EXIT;
/
