--*******************************************************
-- Demo: Oracle-XML 
-- Author: Dr. Can Trker
--*******************************************************

SET FEEDBACK 1;
SET ECHO ON;
SET LONG 8000;

--*******************************************************
-- Register XML schema
--*******************************************************

DECLARE
  doc VARCHAR2(3000) := 
    '<schema xmlns="http://www.w3.org/2001/XMLSchema"
             targetNamespace="emp.xsd"
             xmlns:emp="emp.xsd"
             xmlns:xdb="http://xmlns.oracle.com/xdb">
       <complexType name = "Employee" xdb:SQLType="EMPTYPE">
         <sequence>
           <element name = "Name" type = "string"/>
           <element name = "Age" type = "decimal"/>
           <element name = "Addr" xdb:SQLType = "ADDRTYPE">
             <complexType >
               <sequence>
                 <element name = "Street" type = "string"/>
                 <element name = "City" type = "string"/>
               </sequence>
             </complexType>
           </element>
         </sequence>
       </complexType>
     </schema>';
BEGIN
  DBMS_XMLSCHEMA.registerSchema('emp.xsd', doc);
END;
/

desc EmpType;

desc AddrType;

BEGIN
  DBMS_XMLSCHEMA.deleteSchema('emp.xsd', 4);
END;
/

DECLARE
  doc VARCHAR2(3000) := 
    '<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:xdb="http://xmlns.oracle.com/xdb">
       <xs:complexType name="Address" xdb:SQLType="ADDR_T">
         <xs:sequence>
           <xs:element name="street" type="xs:string"/>
           <xs:element name="city" type="xs:string"/>
         </xs:sequence>
       </xs:complexType>
       <xs:complexType name="USAddress" xdb:SQLType="USADDR_T">
         <xs:complexContent>
           <xs:extension base="Address">
             <xs:sequence>
               <xs:element name="zip" type="xs:string"/>
             </xs:sequence>
           </xs:extension>
         </xs:complexContent> 
       </xs:complexType>
       <xs:complexType name="IntlAddress" final="#all" xdb:SQLType="INTLADDR_T">
         <xs:complexContent>
           <xs:extension base="Address">
             <xs:sequence>
               <xs:element name="country" type="xs:string"/>
             </xs:sequence>
           </xs:extension>
         </xs:complexContent>
      </xs:complexType>
    </xs:schema>';
BEGIN
  DBMS_XMLSCHEMA.registerSchema('emp.xsd', doc);
END;
/

DESC ADDR_T;

DESC USADDR_T;

DESC INTLADDR_T;

BEGIN
  DBMS_XMLSCHEMA.deleteSchema('emp.xsd', 4);
END;
/

EXIT;
/
