--*******************************************************
-- Demo: PostgreSQL-XML
-- Author: Dr. Can Trker
--*******************************************************

SELECT XML('<?xml version="1.0"?><book><title>Manual</title><chapter>...</chapter></book>');
SELECT XML('abc<foo>bar</foo><bar>foo</bar>');

SELECT XML('<?xml version="1.0"?><book><title>Manual</title><chapter>...</chapter></book>') IS DOCUMENT;
SELECT XML('abc<foo>bar</foo><bar>foo</bar>') IS DOCUMENT;

SELECT XMLPARSE(DOCUMENT '<?xml version="1.0"?><book><title>Manual</title><chapter>...</chapter></book>');
SELECT XMLPARSE(CONTENT 'abc<foo>bar</foo><bar>foo</bar>');

SELECT XMLPARSE(DOCUMENT 'abc<foo>bar</foo><bar>foo</bar>');
-- returns error: invalid XML document

SELECT XMLSERIALIZE(DOCUMENT '<?xml version="1.0"?><book><title>Manual</title><chapter>...</chapter></book>' AS TEXT);
SELECT XMLSERIALIZE(CONTENT 'abc<foo>bar</foo><bar>foo</bar>' AS TEXT);

SELECT XMLROOT(XMLPARSE(DOCUMENT '<?xml version="1.1"?><content>abc</content>'), version '1.0', standalone yes);

SELECT XMLCOMMENT('hello');
SELECT XMLCONCAT('<abc/>', '<bar>foo</bar>');
SELECT XMLCONCAT(XML('<abc/>'), XML('<bar>foo</bar>'));
SELECT XMLELEMENT(name foo);
SELECT XMLELEMENT(name foo, xmlattributes('xyz' as bar));
SELECT XMLELEMENT(name foo, xmlattributes(current_date as bar), 'cont', 'ent');
SELECT XMLELEMENT(name "foo$bar", xmlattributes('xyz' as "a&b"));
SELECT XMLFOREST('abc' AS foo, 123 AS bar);
SELECT XMLPI(name php, 'echo "hello world";');

SELECT XMLROOT(XMLPARSE(DOCUMENT '<?xml version="1.1"?><content>abc</content>'), version '1.0', standalone yes) IS DOCUMENT;
SELECT XMLCONCAT('<abc/>', '<bar>foo</bar>') IS DOCUMENT;

SELECT XML_IS_WELL_FORMED('<>');
SELECT XML_IS_WELL_FORMED('<abc/>');
SELECT XML_IS_WELL_FORMED('abc');
SELECT XML_IS_WELL_FORMED_DOCUMENT('<pg:foo xmlns:pg="http://postgresql.org/stuff">bar</pg:foo>');
SELECT XML_IS_WELL_FORMED_DOCUMENT('<pg:foo xmlns:pg="http://postgresql.org/stuff">bar</my:foo>');
SELECT XML_IS_WELL_FORMED_DOCUMENT('bar');
SELECT XML_IS_WELL_FORMED_CONTENT('<pg:foo xmlns:pg="http://postgresql.org/stuff">bar</pg:foo>');
SELECT XML_IS_WELL_FORMED_CONTENT('<pg:foo xmlns:pg="http://postgresql.org/stuff">bar</my:foo>');
SELECT XML_IS_WELL_FORMED_CONTENT('bar');

SELECT XMLEXISTS('//town[text() = ''Toronto'']' PASSING BY REF '<towns><town>Toronto</town><town>Ottawa</town></towns>');

SELECT XPATH('/my:a/text()', '<my:a xmlns:my="http://example.com">test</my:a>', ARRAY[ARRAY['my', 'http://example.com']]);
SELECT XPATH_EXISTS('/my:a/text()', '<my:a xmlns:my="http://example.com">test</my:a>', ARRAY[ARRAY['my', 'http://example.com']]);
